#version 120

uniform sampler2D sampler;
uniform sampler2D bump1;
uniform sampler2D bump2;

uniform float samplerSize;
uniform float bumpSize;
uniform float range = 50;
uniform float bumpFactor = 0.5f;
uniform float bumpOffset = 0.0f;

const float bright = 0.15f;

void main() {
	vec2 pos = gl_TexCoord[0].xy;
	vec2 bumpPos = gl_TexCoord[0].xy * samplerSize / bumpSize;
	bumpPos.y += bumpOffset;
	float height1 = texture2D(bump1, bumpPos).a - 0.5f;
	float height2 = texture2D(bump2, bumpPos).a - 0.5f;
	float height = mix(height1, height2, bumpFactor);
	pos.y += height * (range / samplerSize);
	
	
	vec4 color = texture2D(sampler, pos);
//	if (height > bright) {
//		float brightMod = (1 + height - bright);
//		color *= 1 + (height - bright) * 3;
//	} else if (height < -bright) {
//		color *= 1 + height + bright;
//	}
	gl_FragColor = color;
}